<?php
if(!function_exists('get_filesize'))
{
	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	# Return the formatted size of a file
	#
	function get_filesize($file_name)
	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	{
		if(file_exists($file_name))
		{
			$size=filesize($file_name);
			return(format_filesize($size));
		}
		return(0);
	}
	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	# Format a filesize
	#
	function format_filesize($size)
	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	{
		if ($size>1024*1024) { $size=number_format(($size/(1024*1024)),2,',','.').' Mb'; }
		elseif ($size>=1024) { $size=number_format(($size/(1024)),1,',','.').' Kb'; }
		elseif ($size<1024) { $size=number_format($size,0,'.','.').' bytes'; }
		return($size);
	}
}
?>